#include<iostream>
#include<fstream>
#include<sstream>
#include<vector>
#include<map>
#include<cstdio>
#include<cstdlib>
#include<cmath>
#include<cstring>
#include<cassert>
#include "Ncbi_nodes_dmp.h"
#include "Ncbi_names_dmp.h"
using namespace std;
void usage(){
	cerr << "ExtractMEGANFile input.reads.annotation "<<endl;
	exit(-1);
}

int main(int argc,char* argv[]){
	if(argc!=2)
		usage();

	NCBI_nodes_dmp NodesDmp;
	Ncbi_nodes_dmp NamesDmp;
	NodesDmp.init("/data/ywang/DB/ori/nodes.dmp");
	NamesDmp.init("/data/ywang/DB/ori/names.dmp");
	const int MAX = 1000;
	char Buf[MAX];
	char buf[MAX];
	map<int,int>TaxonNReads;
	ifstream ifs(argv[1]);
	if(ifs.fail()){
		cerr << "File Open failed: " << argv[1] << endl;
		exit(-1);
	}
	int currentTaxon = -1;
	while(!ifs.eof()){
		ifs.getline(Buf,MAX);
		if(Buf[0]!='>'){
			currentTaxon = -1;
			if(Buf[6]!='u' && Buf[7]!='n'){
				char* str=Buf;
				while(*str && *str!=':')++str;
				if(*str==':')
					currentTaxon = atoi(++str);
			}
		}else{
			if(currentTaxon > 0){
				++TaxonNReads[currentTaxon];
		/*		sscanf(Buf+1,"%s",buf);
				ofs << buf << '\t' << currentTaxon << endl;
				*/
			}
		}
	}
	ifs.close();
	ofstream ofs((string(argv[1])+".bac.megan.txt").c_str());
	assert(!ofs.fail());
	long long sum = 0,bacsum = 0;
	for(map<int,int>::const_iterator itr=TaxonNReads.begin();itr!=TaxonNReads.end();++itr){
		sum += itr->second;
		vector<int>pT7 = NodesDmp.getT7(itr->first);
		for(int i=0;i<7;++i)
			cout << pT7[i] <<'\t';
		cout << endl;
		if(pT7[6]==2){
			ofs << NamesDmp.getName(itr->first) << '\t' << (itr->second) << endl;
			bacsum += itr->second;
		}
	}
	ofs.close();
	cerr << sum << '\t' << bacsum << endl;
	return 0;
}
