#ifndef MCH_HYBRID_NCBINAMESDMP_H_

#define MCH_HYBRID_NCBINAMESDMP_H_
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <cassert>
#include <cstring>
#include <cstdlib>
using namespace std;

class Ncbi_names_dmp
{
public:
	explicit Ncbi_names_dmp(){}
	void init(string path)
	{
		ifstream ifs(path.c_str());
		if(ifs.fail()){
			cerr<<"File Open Error:" << path << endl;
			exit(-1);
		}
		Names.resize(MAXTAXID);
		const int MAX = 10000;
		char Buf[MAX];
		while(!ifs.eof()){
			ifs.getline(Buf,MAX);
			if(strlen(Buf)<=1)continue;
			for(char* str = Buf;*str;++str){
				if(*str==' ')*str='_';
				else if(*str=='|')*str=' ';
			}
			int Tid = atoi(Buf);
			assert(Tid>=0 && Tid < MAXTAXID);
			string part[4];
			stringstream ss(Buf);
			for(int i=0;i<4;++i)
				ss >> part[i];
			if(part[2]=="scientific_name" || part[3]=="scientific_name"){
				for(int i=0;i<part[1].size();++i){
					if(!(('a'<=part[1][i] && 'z'>=part[1][i]) ||
					   ('A'<=part[1][i] && 'Z'>=part[1][i]) ||
					   ('0'<=part[1][i] && '9'>=part[1][i]) ||
					   (part[1][i]=='_')))
						part[1][i]='_';
				}
				///////////////////////////////////////////////////////
				if(part[2]=="scientific_name")
					Names[Tid] = part[1];
				else
					Names[Tid] = part[2];
			}
		}
		ifs.close();
	}
	string getName(int taxid)const
	{
		if(taxid < 0 || taxid > MAXTAXID)
			return "";
		else return Names[taxid];
	}
	virtual ~Ncbi_names_dmp(){}
private:
	vector<string>Names;
	const static int MAXTAXID = 2000000;
	Ncbi_names_dmp(const Ncbi_names_dmp& ncbi_nodes_dmp){}
	const Ncbi_names_dmp& operator=(const Ncbi_names_dmp& ncbi_nodes_dmp){return*this;}
};
#endif
